const Ci = Components.interfaces;
const Cc = Components.classes;
const ENGINE_FLAVOR = "text/x-moz-search-engine";

var cqr_Manager = {
	cqrList : null,
	cqrView : null,
	sBarList : null,
	sBarView : null,
	sBarHash : null,
	
	init : function(){
		this.cqrList = document.getElementById('EntryList');
		this.sBarList = document.getElementById('AllEngines');
		cqrPref.LoadMain();
		cqrPref.LoadEntries();
		this.read_sBarHash();
		setTimeout(this.initWithDelay, 0);
	},
	
	initWithDelay : function(){
		with(cqr_Manager){
			fillprefstab();
			cqrView = new cqr_treeView(EntryHash);
			cqrList.view = cqrView;
			sBarView = new cqr_treeView(sBarHash);
			sBarList.view = sBarView;
			checkHotMenuStatus();
			checkInMainMenuStatus();
			window.sizeToContent();
		}
	},
	
	read_sBarHash : function(){
		this.sBarHash = new PreEntries();
		var entries = cqrSearchService.getEngines({});
		entries.forEach(this.sBarHash.Add, this.sBarHash);
	},
	
	ReloadTree : function(){
		if(document.getElementById('ptabbox').selectedTab.id == "ActTab"){
			this.cqrView.invalidate();
		}else if(document.getElementById('ptabbox').selectedTab.id == "ALLenginesTab"){
			this.sBarView.invalidate();
		}
	},
	
	Delete : function(){
		if(document.getElementById('ptabbox').selectedTab.id == "ActTab"
				&& this.cqrList.currentIndex != -1){
			var id = this.cqrView._Visible[this.cqrList.currentIndex].eId;
		}else if(document.getElementById('ptabbox').selectedTab.id == "ALLenginesTab"
				&& this.sBarList.currentIndex != -1){
			var id = this.sBarView._Visible[this.sBarList.currentIndex].eId;
		}else return;
		if(confirm(cqr_GetString('cqr.cfg.cfm.delete'))){
			var engin = cqrSearchService.getEngineByName(id);
			delete EntryHash.Items[id];
			EntryHash.sort();
			delete this.sBarHash.Items[id];
			this.sBarHash.sort();
			cqrSearchService.removeEngine(engin);
			this.cqrView.invalidate();
			this.sBarView.invalidate();
		}
	},
	
	onSelect : function(){
		if(document.getElementById('ptabbox').selectedTab.id == "ActTab"
				&& this.cqrList.currentIndex != -1){
			var eId = this.cqrView._Visible[this.cqrList.currentIndex].eId;
			var disc = document.getElementById('Desc');
		}else if(document.getElementById('ptabbox').selectedTab.id == "ALLenginesTab"
				&& this.sBarList.currentIndex != -1){
			var eId = this.sBarView._Visible[this.sBarList.currentIndex].eId;
			var disc = document.getElementById('AllDesc');
		}else return;
		var desctext = "";
		var engin =  cqrSearchService.getEngineByName(eId);
		var Description = engin.description || "";
		desctext = engin.name + ":\n" + engin.searchForm + "\n" + Description;
		var submission = engin.getSubmission("Selection", null);
		var url = "";
		var postData = { value: null };
		if (submission) {
			url = submission.uri.spec;
			postData.value = submission.postData;
		}
		var Method = engin.method || "";
		var IconURL = engin.iconURI.spec || "";
		desctext += cqr_GetString('cqr.cfg.descrInps') + "Action = " + url + "\nPostData = " + postData.value
				+ "\nIconURL = " + IconURL + "\nMethod = " + Method + "\n";
		disc.value = desctext;
	},
	
	execQuery : function(e){
		if(document.getElementById('ptabbox').selectedTab.id == "ActTab"
				&& this.cqrList.currentIndex != -1){
			var eId = this.cqrView._Visible[this.cqrList.currentIndex].eId;
		}else if(document.getElementById('ptabbox').selectedTab.id == "ALLenginesTab"
				&& this.sBarList.currentIndex != -1){
			var eId = this.sBarView._Visible[this.sBarList.currentIndex].eId;
		}else return;
		window.close();
		var targetWindow = cqr_mostRecentWindow();
		if(targetWindow){
			var obj = {id : eId};
			targetWindow.conQuery.ProcessEntry(e, obj);
		}
	},
	
	move : function(unit){
		if(document.getElementById('ptabbox').selectedTab.id == "ActTab"){
			var curIndex = this.cqrList.currentIndex;
			this.cqrView.movePlg(curIndex, curIndex - unit);
		}else if(document.getElementById('ptabbox').selectedTab.id == "ALLenginesTab"){
			var curIndex = this.sBarList.currentIndex;
			this.sBarView.movePlg(curIndex, curIndex - unit);
		}
	},
	
	onAccept : function(){
		cqrPref.SaveMain();
		setPrefOrder();
		cqr_notifySengineChanged();
		cqr_mostRecentWindow().conQuery.updateState();
		
		function setPrefOrder() {
			cqr_Manager.sBarHash.sort();
			var i = 0;
			for each (var Item in cqr_Manager.sBarHash.Items) {
				var engin = cqrSearchService.getEngineByName(Item.eId);
				if(Item.hidden) engin.hidden = Item.hidden;
				else cqrSearchService.moveEngine(engin, i++);
			}
		}
	},
	
	fillprefstab : function() {
		with(cqrPref){
			document.getElementById('enhotmenu').checked = UseHotMenu;
			document.getElementById('HTTPIcon').checked = HTTPIcon;
			document.getElementById('hidefromtools').checked = HideFromTools;
			document.getElementById('cspInMainMenu').checked = ShowCSPInMainMenu;
			document.getElementById('cqrHideQueryTo').checked = HideQueryTo;
			document.getElementById('MainContextLimit').value = MainContextLimit;
			document.getElementById("enhotmenu").checked = UseHotMenu;
			document.getElementById('MCDelayOn_tb').value = MiddleClickDelayms;
			document.getElementById('MCDelayOff_tb').value = MiddleClickHidems;
			document.getElementById('open_res').value = OpenRes;
			document.getElementById('hotmenu_style').selectedIndex = UseCtrlForHM ? 0 : 1;
		}
	},
	
	checkHotMenuStatus : function(){
		var c1 = document.getElementById('enhotmenu').checked;
		var c2 = c1 && document.getElementById('middleclick').selected;
		document.getElementById('hotmenu_style').disabled = !c1;
		var obs = document.getElementById('useMiddleClick');
		if(c2)
			obs.removeAttribute('disabled', true);
		else
			obs.setAttribute('disabled', true);
	},
	
	checkInMainMenuStatus : function(){
		var obs = document.getElementById('showCspInMainMenu');
		if(document.getElementById('cspInMainMenu').checked)
			obs.removeAttribute('disabled', true);
		else
			obs.setAttribute('disabled', true);
	}
	
}

function cqr_treeView(aEntries){
	this._entries = aEntries;
	this._Visible = this.Visibles;
	this.treebox = null;
	this._dragService = null;
}

cqr_treeView.prototype = {
	invalidate: function () {
		this._visibles = [];
		var tempCount = this.rowCount;
		this._Visible = this.Visibles;
		this.treebox.rowCountChanged(this.rowCount, this.rowCount - tempCount);
		this.treebox.invalidate();
	},
	invalidateRange: function(from, to){
		this.treebox.invalidateRange(from < to ? from : to, from > to ? from : to);
	},
	get dragService(){
		if(!this._dragService)
			this._dragService = Cc["@mozilla.org/widget/dragservice;1"].
						getService().QueryInterface(Ci.nsIDragService);
		return this._dragService;
	},
	movePlg : function(fromI, toI){
		if(toI < 0 || toI >= this.rowCount) return;
		var temp = this._Visible[fromI];
		var pId = this._Visible[fromI].eId;
		var sId = this._Visible[toI].eId;
		var order = this._entries.Items[pId].order;
		this._entries.Items[pId].order = this._entries.Items[sId].order;
		this._entries.Items[sId].order = order;
		this._Visible = this.Visibles;
		this.invalidateRange(fromI, toI);
		this.selection.select(toI);
		this.treebox.ensureRowIsVisible(toI);
	},
	getSourceIndexFromDrag: function () {
		var dragSession = this.dragService.getCurrentSession();
		var Transfer = Cc["@mozilla.org/widget/transferable;1"].
						createInstance(Ci.nsITransferable);
		Transfer.addDataFlavor(ENGINE_FLAVOR);
		dragSession.getData(Transfer, 0);
		
		var dataObj = {};
		var len = {};
		var sourceIndex = -1;
		try {
			Transfer.getAnyTransferData({}, dataObj, len);
		} catch (ex) {}
		
		if (dataObj.value) {
			sourceIndex = dataObj.value.QueryInterface(Ci.nsISupportsString).data;
			sourceIndex = parseInt(sourceIndex.substring(0, len.value));
		}
		return sourceIndex;
	},
	startDrag: function(aEvent){
		var selectedIndex = this.selectedIndex;
		if (selectedIndex == -1) return;
		
		var dragData = Cc["@mozilla.org/supports-string;1"].
					createInstance(Ci.nsISupportsString);
		var Transfer = Cc["@mozilla.org/widget/transferable;1"].
					createInstance(Ci.nsITransferable);
		Transfer.addDataFlavor(ENGINE_FLAVOR);
		
		var indexStr = selectedIndex.toString();
		dragData.data = indexStr;                         // 2 bytes per character
		Transfer.setTransferData(ENGINE_FLAVOR, dragData, indexStr.length * 2);
		
		var transArray = Cc["@mozilla.org/supports-array;1"].
					createInstance(Ci.nsISupportsArray);
		Transfer.QueryInterface(Ci.nsISupports)
		transArray.AppendElement(Transfer);
		
		this.dragService.invokeDragSession(aEvent.target, transArray, null,
					Ci.nsIDragService.DRAGDROP_ACTION_MOVE);
	},
	canDrop: function(targetIndex, orientation) {
		var sourceIndex = this.getSourceIndexFromDrag();
		return sourceIndex != -1;
	},
	drop: function(newIndex, orientation) {
		var sourceIndex = this.getSourceIndexFromDrag();
		if (sourceIndex == -1) return;
		newIndex = (newIndex > sourceIndex && orientation == -1) ? newIndex + orientation :
		(newIndex < sourceIndex && orientation == 1) ? newIndex + orientation :
		newIndex;
		if (newIndex == sourceIndex) return;
		var newOrder = this._Visible[newIndex].order - 1;
		var source = this._Visible[sourceIndex];
		this._entries.sort();
		var temp = [];var i = 0;
		for each(var item in this._entries.Items){
			if(newOrder == i) temp.push(source);
			if(item.eId != source.eId){temp.push(item);i++;}
		}
		if(newOrder == i) temp.push(source);
		this._entries.clear();
		temp.forEach(function(element, index){
			this.Items[element.eId] = element;
			this.Items[element.eId].order = index + 1;
		},this._entries);
		this._Visible = this.Visibles;
		this.invalidateRange(sourceIndex, newIndex);
		this.selection.select(newIndex);
	},
	get selectedItem() {
		return this.selection;
	},
	get selectedIndex() {
		return this.selection.currentIndex;
	},
	get Visibles(){
		var retItem = [];
		var vItems = this._visibles ? this._visibles : [];
		this._visibles = [];
		var showflg = document.getElementById('ptabbox').selectedTab.id == "ActTab" ? document.getElementById('showblocked').checked
					: document.getElementById('ptabbox').selectedTab.id == "ALLenginesTab" ? document.getElementById('showhidden').checked
					: false;
		this._entries.sort();
		for each (var item in this._entries.Items){
			if(showflg || !item.hidden || (vItems && vItems[item.eId])){
				this._visibles[item.eId] = true;
				retItem.push(item);
			}
		}
		return retItem;
	},
		get rowCount (){
		return this._Visible.length;
	},
	getCellText : function(row, col){
		return this._Visible[row][col.id];
	},
	setTree: function(treebox) {
		this.treebox = treebox;
	},
	getImageSrc: function(row,col){
		return this._Visible[row][col.id];
	},
	getCellValue: function(row,col){
		return !this._Visible[row][col.id];
	},
	setCellValue: function(row,col,value){
		this._entries.Items[this._Visible[row].eId].hidden = !this._Visible[row].hidden;
	},
	isEditable: function(row,col){
		return col.editable;
	},
	getRowProperties: function(row,props){},
	performAction: function(action) {},
	performActionOnCell:function(action,row,col){},
	getParentIndex: function(index) { return -1; },
	cycleHeader: function(col) {},
	isContainer: function(row){ return false; },
	isSeparator: function(row){ return false; },
	isSorted: function(){ return false; },
	getLevel: function(row){ return 0; },
	getCellProperties: function(row,col,props){},
	getColumnProperties: function(colid,col,props){}
};

function PreEntries(){
	this.Items = [];
	
	this.sort = function(){
		var items = [];
		var tmpArr = [];
		for each (var item in this.Items) tmpArr.push(item);
		tmpArr.sort(this._Cmp);
		this.Items = [];
		tmpArr.forEach(order, this);
		
		function order(element, index){
			element.order = index + 1;
			this.Items[element.eId] = element;
		}
	}
	
	this.Add = function(element, index){
		var eId = element.name;
		this.Items[eId] = [];
		this.Items[eId].eId = element.name;
		this.Items[eId].order = index + 1;
		this.Items[eId].hidden = element.hidden;
		this.Items[eId].iconpath = element.iconURI.spec;
	}
	
	this._Cmp = function(a, b){
		return a.order - b.order;
	}
	
	this.clear = function(){
		this.Items = [];
	}
}
