// Content variables globals
var cqrPageSelection = "";

//Inits
var conQuery = {
	cancel : false,
	init : function(){
		window.addEventListener('unload', conQuery.unInit, false);
		window.removeEventListener('load', conQuery.init, false);
		getBrowser().addEventListener('contextmenu', conQuery.getParams, true);
		conQuery.updateState();
	},
	
	unInit : function(){
		window.removeEventListener('unload', conQuery.unInit, false);
		getBrowser().removeEventListener('contextmenu', conQuery.getParams, true);
		if(conQuery.HandleContextMenu.enabled)
			getBrowser().removeEventListener('contextmenu', conQuery.HandleContextMenu.context, true);
		if(conQuery.MbuttonHandler.enabled){
			getBrowser().removeEventListener('mousedown', conQuery.MbuttonHandler.Down, true);
			window.removeEventListener('mouseup', conQuery.MbuttonHandler.Up, true);
		}
	},
	
	updateState : function(){
		with(cqrPref){
			LoadMain();
			if(!this.HandleContextMenu.enabled && UseCtrlForHM && UseHotMenu){
				getBrowser().addEventListener('contextmenu', conQuery.HandleContextMenu.context, true);
				this.HandleContextMenu.enabled = true;
			}else if(this.HandleContextMenu.enabled && (!UseCtrlForHM || !UseHotMenu)){
				getBrowser().removeEventListener('contextmenu', conQuery.HandleContextMenu.context, true);
				this.HandleContextMenu.enabled = false;
			}
			if(!this.MbuttonHandler.enabled && UseMiddleClickForHM && UseHotMenu){
				getBrowser().addEventListener('mousedown', conQuery.MbuttonHandler.Down, true);
				window.addEventListener('mouseup', conQuery.MbuttonHandler.Up, true);
				this.MbuttonHandler.enabled = true;
			}else if(this.MbuttonHandler.enabled && (!UseMiddleClickForHM || !UseHotMenu)){
				getBrowser().removeEventListener('mousedown', conQuery.MbuttonHandler.Down, true);
				window.removeEventListener('mouseup', conQuery.MbuttonHandler.Up, true);
				this.MbuttonHandler.enabled = false;
			}
			document.getElementById('cq-cfg-menu').hidden = HideFromTools;
			document.getElementById("cq-menu").hidden = HideQueryTo;
			LoadEntries();
		}
	},
	
	HandleContextMenu : {
		enabled :false,
		context : function(e){
			try{
				if(e.shiftKey || e.ctrlKey ){
					var eventX = e.clientX;
					var eventY = e.clientY; 
					document.popupNode = e.target;
					e.preventDefault();
					cqrShowHotmenu(true, eventX, eventY);
				} else {
					conQuery.FillMainMenu();
				}
			}catch(err){cqerr(err, 'ContextMenu handler')}
		}
	},
	
	MbuttonHandler : {
		enabled : false,
		MouseUp : true,
		Timer : null,
		Down : function(e){
			if (e.button==1){
				conQuery.MbuttonHandler.MouseUp = false;
				document.popupNode = e.target;
				var eventX = e.clientX;
				var eventY = e.clientY; 
				conQuery.getParams(e);
				
				// will open popup after delay if the middle mouse button wasn't released
				this.Timer = setTimeout(function() {
					cqrShowHotmenu('yes', eventX, eventY);
					
					// and will close popup after after a while if button isn't released
					if (cqrPref.MiddleClickHidems != 0) {
						setTimeout(function() {
							if (!conQuery.MbuttonHandler.MouseUp) {
								var hotmenu = window.document.getElementById("cq-hotmenu");
								if(hotmenu) hotmenu.hidePopup();
								conQuery.reset();
							}
						}, cqrPref.MiddleClickHidems);
					}
				}, cqrPref.MiddleClickDelayms);
			}
		},
		
		Up : function(e){
			if (e.button==1){
				conQuery.MbuttonHandler.MouseUp = true;
				clearTimeout(this.Timer);
			}
		}
	},
	
	RbuttonHandler : {
		Timer : null,
		Down : function(e, obj){
			if (e.button==2){
				this.MouseUp = false;
				this.Timer = setTimeout(function(obj) {
					var hotmenu = window.document.getElementById("cq-hotmenu");
					if(hotmenu) hotmenu.hidePopup();
					var retVal = {value:cqrPageSelection, cancel:true};
					window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", EntryHash.Items[obj.id], retVal);
					cqrPageSelection = retVal.value;
					conQuery.cancel = retVal.cancel;
					conQuery.doQuery(obj.id);
					conQuery.reset();
				}, 300, obj);
			}
		},
		
		Up : function(e){
			if (e.button==2 && this.Timer){
				clearTimeout(this.Timer);
			}
		}
	},
	
	FillMenu : function(kShift){
		try{
			var hasEntries = false;
			cqrPref.QuickLoadAll();
			
			if (kShift){// && cqrPref.UseHotMenu) {
				var ppMenu = document.getElementById("cq-hotmenu");
				var entries = EntryHash.conquerySet(0);
				//var forceCSPShowInMain = true;
			} else if(!cqrPref.ShowCSPInMainMenu) {
				var ppMenu = document.getElementById("cq-ppm");
				var entries = EntryHash.conquerySet(0);
				//var forceCSPShowInMain = false;
			} else {
				var ppMenu = document.getElementById("cq-ppm");
				var entries = EntryHash.conquerySet(cqrPref.MainContextLimit);
				//var forceCSPShowInMain = false;
			}
			
			while (ppMenu.hasChildNodes()) ppMenu.removeChild(ppMenu.lastChild);
			for each (var entry in entries) {
				hasEntries = true;
				mItem = this.crtMenuItem(document, entry, "conquerySet");
				ppMenu.appendChild(mItem);
			}
			
			if(!hasEntries){
				var mItem = document.createElement("menuitem");
				with(mItem){
					setAttribute("class", "menuitem-iconic");
					setAttribute("label", cqr_GetString('cqr.menu.NoPluginsFound'));
					setAttribute("tooltiptext", cqr_GetString('cqr.menu.ClickToConfigure'));
					setAttribute("oncommand", "conQuery.OpenCfg();");
					setAttribute("conquery_flag", "conquerySet");
				}
				ppMenu.appendChild(mItem);
			}
		}catch(er){cqerr(er, "FillMenu")}
	},
	
	FillMainMenu : function(){
		try{
			if(cqrPref.HideQueryTo) return;
			var entriesTrash = [];
			var bContextMenu = document.getElementById("contentAreaContextMenu");
			for (i=0; i < bContextMenu.childNodes.length; i++){
				if(bContextMenu.childNodes[i].getAttribute("conquery_flag")!="")
					entriesTrash.push(bContextMenu.childNodes[i]);
			}
			for each (var entry in entriesTrash) bContextMenu.removeChild(entry);
			
			if (!cqrPref.ShowCSPInMainMenu) return;
			var cqmenu = document.getElementById("cq-menu");
			if (cqrPref.MainContextLimit > 0){
				bContextMenu.insertBefore(this.crtSeparator(document), cqmenu);
				cqrPref.QuickLoadAll();
				
				var entries = EntryHash.mainSet(cqrPref.MainContextLimit);
				for each (var entry in entries)
					bContextMenu.insertBefore(this.crtMenuItem(document, entry, "mainSet"), cqmenu);
			}
		}catch(er){cqerr(er, "FillMainMenu sub")}
	},
	
	crtMenuItem : function(doc, entry, flag){
		var retItem = doc.createElement("menuitem");
		with(retItem){
			setAttribute("class", "menuitem-iconic");
			if (!entry.iconpath){
				if (cqrPref.HTTPIcon){
					var engin =  cqrSearchService.getEngineByName(entry.eId);
					var icourl = url2host(engin.searchForm);
					if (icourl) {setAttribute("src", icourl + "/favicon.ico")};
				}
			}else{
				setAttribute("src", entry.iconpath);
			}
			setAttribute("label", entry.eId);
			setAttribute("id", entry.eId);
			setAttribute("tooltiptext", cqr_GetString('cqr.menu.plgToolTip'));
			setAttribute("onclick", "conQuery.ProcessEntry(event, this)");
			setAttribute("oncommand", "conQuery.ProcessEntry(event, this)");
			setAttribute("onmousedown", "conQuery.RbuttonHandler.Down(event, this)");
			setAttribute("onmouseup", "conQuery.RbuttonHandler.Up(event, this)");
			setAttribute("conquery_flag", flag);
		}
		return retItem;
	},
	
	crtSeparator : function(doc){
		retItem = doc.createElement("menuseparator");
		retItem.setAttribute("conquery_flag", "conquery");
		return retItem;
	},
	
	ProcessEntry : function(e, obj){
		if(e.type == "command")
			try{
				obj.removeAttribute("onclick", "conQuery.ProcessEntry(event, this)");
			}catch(e){}
		else if(!e.ctrlKey)
			cqrPageSelection = "";
		if (e.ctrlKey || cqrPageSelection == "" || (e.button && e.button == 2)){
			var retVal = {value:cqrPageSelection, cancel:true};
			window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", EntryHash.Items[obj.id], retVal);
			cqrPageSelection = retVal.value;
			this.cancel = retVal.cancel;
		}
		this.doQuery(obj.id);
		this.reset();
	},
	
	doQuery : function(aId){
		if(this.cancel || cqrPageSelection == "") return;
		
		var submission = cqrSearchService.getEngineByName(aId).getSubmission(cqrPageSelection, null);
		if (!submission) return;
		
		var postData = { value: null };
		var url = submission.uri.spec;
		postData.value = submission.postData;//myDump(entry.eId +"\n"+ cqrOpenRes +"\n"+ cqrPageSelection +"\n"+ EntryId +"\n"+ url +"\n"+ postData.value +"\n"+  EntryId);
		
		var useTargetForOpen = cqrPref.OpenRes || "tab_bg";
		
		if(useTargetForOpen == "tab_fg"){
			getBrowser().loadOneTab(url, null, null, postData.value, false);
		}else if(useTargetForOpen == "tab_bg"){
			getBrowser().addTab(url, null, null, postData.value, false);
		}else if(useTargetForOpen == "same_win"){
			getBrowser().loadURI(url, null, postData.value);
		}else if(useTargetForOpen == "win_fg"){
			window.open(url);
		}else if(useTargetForOpen == "win_bg"){
			window.open(url);
			window.focus();
		}
	},
	
	OpenCfg : function(){
		window.openDialog("chrome://conquery/content/conquery-pref.xul", cqr_GetString('cqr.cfg.wTitle'), "centerscreen,chrome,modal,resizable=yes");
	},
	
	getParams : function(e){
		var focusedWindow = document.commandDispatcher.focusedWindow;
		try{
			cqrPageSelection = "";
			var node = e.explicitOriginalTarget;
			if ((node) && 
					((node.nodeName.toUpperCase() == "TEXTAREA") ||
					(node.nodeName.toUpperCase() == "INPUT" && node.type == "text"))) {
				cqrPageSelection = node.value.substring(node.selectionStart, node.selectionEnd);
			}else{
				var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
				cqrPageSelection = winWrapper.getSelection();
			}
		}catch(er){cqrPageSelection=""}
	},
	
	reset : function(){
		cqrPageSelection = "";
		this.cancel = false;
	}
}
window.addEventListener('load', conQuery.init, false);

/// HotMenu. Idea and early realizations made by Henrik Gulbrandsen.
function cqrShowHotmenu(kShift, x, y){
	try{
		var hotmenu = document.getElementById("cq-hotmenu");
		if (!hotmenu) {
			hotmenu = document.createElement("menupopup");
			hotmenu.id = "cq-hotmenu";
			getBrowser().appendChild(hotmenu);
		}
		//hotmenu.position = 'at_pointer'; //at_pointer
		conQuery.FillMenu(kShift);
		hotmenu.showPopup(getBrowser(), x, y, "context","bottomleft","topleft");
	}catch(er){cqerr(er, "cqrShowHotmenu sub")}
}
