//Entries holder:
var _ProtoHash = function(){
	this.Items = [];
	
	this._AddEntryObj = function(element, index){
		var eId = element.name;
		this.Items[eId] = new ProtoEntry();
		this.Items[eId].eId = eId;
		this.Items[eId].iconpath = element.iconURI.spec;
		cqrPref.UpdateEntry(eId);
		if(this.Items[eId].order == 0) this.Items[eId].order = index + 2;
		
		//Plugin data holder
		function ProtoEntry(){
			this.eId = "";
			this.order = 0;
			this.hidden = false;
			this.iconpath = "";
		}
	}
	
	this.sort = function(){
		var tmpArr = [];
		for each (var item in this.Items) tmpArr.push(item);
		tmpArr.sort(this._Cmp);
		this.clear();
		tmpArr.forEach(order, this);
		
		function order(element, index){
			element.order = index + 1;
			this.Items[element.eId] = element;
			//cqrPref.SaveEntry(element);
		}
	}
	
	this.mainSet = function(limit){
		var retItems = [];
		if (limit == 0) return retItems;
		var i=0;
		for each (var item in this.Items){
			if (i >= limit) break;
			if (item.hidden == false){
				retItems[item.eId] = item;
				i++;
			}
		}
		return retItems;
	}
	
	this.conquerySet = function(limit){
		var retItems = [];
		var i=0;
		for each (var item in this.Items){
			if (item.hidden == false){
				if (i >= limit) retItems[item.eId] = item;
				i++;
			}
		}
		return retItems;
	}
	
	this._Cmp = function(a, b){
		return a.order - b.order;
	}
	
	this.clear = function(){
		this.Items = [];
	}
}

 /////// END classes ////////
////////////////////////////


 ////////////////////////////
//////// Globals ///////////

//Active Entries holder
var EntryHash = new _ProtoHash();


/// Prefs globals ///
const cqrSearchService = Components.classes["@mozilla.org/browser/search-service;1"]
				.getService(Components.interfaces.nsIBrowserSearchService);
const cqr_strings = Components.classes["@mozilla.org/intl/stringbundle;1"].
		getService(Components.interfaces.nsIStringBundleService).
		createBundle("chrome://conquery/locale/conquery.properties");


var cqrPref = {
//main prefname
	UseHotMenu : false,
	HTTPIcon : true,
	OpenRes : "tab_bg",
	HideFromTools : false,
	ShowCSPInMainMenu : false,
	HideQueryTo : false,
	MainContextLimit : 3,
	UseCtrlForHM : false,
	UseMiddleClickForHM : false,
	MiddleClickDelayms : 0,
	MiddleClickHidems : 0,
//
	_Prefs : null,
	get Prefs(){
		if(this._Prefs == null)
		this._Prefs = Components.classes["@mozilla.org/preferences-service;1"].
			getService(Components.interfaces.nsIPrefBranch);
		return this._Prefs;
	},
	
	LoadMain : function(){
		with(this){
			UseHotMenu = get("Main.UseHotMenu", UseHotMenu);
			UseCtrlForHM = get("Main.UseCtrlForHM", UseCtrlForHM);
			UseMiddleClickForHM = get("Main.UseMiddleClickForHM", UseMiddleClickForHM);
			MiddleClickDelayms = get("Main.MiddleClickDelayms", MiddleClickDelayms);
			MiddleClickHidems = get("Main.MiddleClickHidems", MiddleClickHidems);
			
			HTTPIcon = get("Main.HTTPIcon", HTTPIcon, HTTPIcon);
			OpenRes = get("Main.OpenResults", OpenRes, OpenRes);
			HideFromTools = get("Main.HideFromTools", HideFromTools);
			ShowCSPInMainMenu = get("Main.ShowCSPInMainMenu", ShowCSPInMainMenu);
			HideQueryTo = get("Main.cqrHideQueryTo", HideQueryTo);
			MainContextLimit = get("Main.MainContextLimit", MainContextLimit);
		}
	},
	
	SaveMain : function(){
		with(this){
			set("Main.UseHotMenu", document.getElementById("enhotmenu").checked);
			set("Main.UseMiddleClickForHM", document.getElementById('middleclick').selected);
			set("Main.UseCtrlForHM", document.getElementById('ctrlshift').selected);
			set("Main.MiddleClickDelayms", parseInt(document.getElementById('MCDelayOn_tb').value));
			set("Main.MiddleClickHidems", parseInt(document.getElementById('MCDelayOff_tb').value));
			set("Main.HTTPIcon", document.getElementById("HTTPIcon").checked);
			set("Main.OpenResults", document.getElementById("open_res").value);
			set("Main.HideFromTools", document.getElementById('hidefromtools').checked);
			set("Main.ShowCSPInMainMenu", document.getElementById('cspInMainMenu').checked);
			set("Main.cqrHideQueryTo", document.getElementById('cqrHideQueryTo').checked);
			set("Main.MainContextLimit", parseInt(document.getElementById('MainContextLimit').value));
			
			SaveEntries();
		}
	},
	
	UpdateEntry : function(id){
		with(EntryHash){
			if (Items[id]){
				var cntx = this.get("Entries."+id, [0, false]);
				if (cntx[1] == "true")
					Items[id].hidden = true;
				else
					Items[id].hidden = false;
				
				if(cntx[0] != 0)
					Items[id].order = parseInt(cntx[0]);
				else
					Items[id].order = 0;
			}
		}
	},
	
	SaveEntries : function(){
		this.Prefs.deleteBranch("conquery.Entries.");
		EntryHash.sort();
		for each (var item in EntryHash.Items)
			this.SaveEntry(item);
	},
	
	SaveEntry : function(entry){
		this.set("conquery.Entries."+entry.eId, [entry.order, entry.hidden]);
	},
	
	LoadEntries : function(){
		EntryHash.clear();
		var lastDirState = cqrSearchService.getEngines({});
		this.curDirState = lastDirState.map(this.setState);
		lastDirState.forEach(EntryHash._AddEntryObj, EntryHash);
		this.SaveEntries();
	},
	
	QuickLoadAll : function(){
		var lastDirState = cqrSearchService.getEngines({});
		
		if(lastDirState.length != this.curDirState.length)
			this.curDirState = lastDirState.map(this.setState);
		else if(!lastDirState.some(this.ischanged, this))
			return;
		
		EntryHash.clear();
		lastDirState.forEach(EntryHash._AddEntryObj, EntryHash);
		this.SaveEntries();
	},
	
	curDirState : [],
	
	setState : function(element) {
		return element.name;
	},
	
	ischanged : function(element, index) {
		var sval = this.curDirState[index] != element.name;
		if(sval) this.curDirState[index] = element.name;
		return sval;
	},
	
	get : function(prefname, value){
		prefname = 'conquery.' + prefname;
		try {
			with(this.Prefs){
				if (typeof(value) == "boolean")
					var scelta = getBoolPref(prefname);
				else if (value instanceof Array)
					var scelta = getCharPref(prefname).split(" ");
				else if (typeof(value) == "string")
					var scelta = getCharPref(prefname);
				else if (typeof(value) == "number")
					var scelta = getIntPref(prefname);
			}
			return scelta;
		} catch (err) {
			cqerr(err, 'cqrPref get')
			this.set(prefname, value);
			return value;
		}
	},
	
	set : function(prefname, value) {
		if(prefname.indexOf('conquery.') != 0)
			prefname = 'conquery.' + prefname;
		with(this.Prefs){
			if (typeof(value) == "boolean")
				setBoolPref(prefname, value);
			else if (value instanceof Array)
				setCharPref(prefname, value.join(" "));
			else if (typeof(value) == "string")
				setCharPref(prefname, value);
			else if (typeof(value) == "number")
				setIntPref(prefname, value);
		}
	}
}

const cqrConsoleService = Components.classes['@mozilla.org/consoleservice;1'].
					getService(Components.interfaces.nsIConsoleService);
function cqerr(r, msg){
	cqrConsoleService.logStringMessage('ConQuery >> ' + msg + ":\n"+r);
}

function url2host(url){
	var re = new RegExp("^http://([^/]*)","ig");
	var retmp = re.exec(url);
	if(retmp)
		return retmp[0];
	else
		return "";
}

function cqr_mostRecentWindow(){
	var  windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].
			getService(Components.interfaces.nsIWindowMediator);
	return windowManager.getMostRecentWindow('navigator:browser');
}

function cqr_GetString(name) {
	return cqr_strings.GetStringFromName(name);
}

function cqr_notifySengineChanged() {
	var os = Components.classes["@mozilla.org/observer-service;1"].
			getService(Components.interfaces.nsIObserverService);
	os.notifyObservers(cqrSearchService.currentEngine, "browser-search-engine-modified" ,"engine-changed");
}
